'use strict';

exports.__esModule = true;
exports.entitiesReducer = entitiesReducer;
exports.combineEntitiesReducers = combineEntitiesReducers;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashLangIsFunction = require('lodash/lang/isFunction');

var _lodashLangIsFunction2 = _interopRequireDefault(_lodashLangIsFunction);

var _lodashObjectMapValues = require('lodash/object/mapValues');

var _lodashObjectMapValues2 = _interopRequireDefault(_lodashObjectMapValues);

function selectEntities(action, name) {
    if (action.payload && action.payload.entities && action.payload.entities[name]) {
        return action.payload.entities[name];
    }
}

function entitiesReducer(reducer, entitiesName) {
    return function (state, action) {
        var newState = state;
        var entities = _lodashLangIsFunction2['default'](entitiesName) ? entitiesName(action) : selectEntities(action, entitiesName);

        if (entities) {
            newState = Object.assign({}, newState, entities);
        }

        return reducer(newState, action);
    };
}

function combineEntitiesReducers(reducers) {
    var entitiesReducers = _lodashObjectMapValues2['default'](reducers, entitiesReducer);
    return function (state, action) {
        if (state === undefined) state = {};
        return _lodashObjectMapValues2['default'](entitiesReducers, function (reducer, key) {
            return reducer(state[key], action);
        });
    };
}